<template>
    <v-app id="app">
        <NavBar/>

        <v-content>
            <v-container>
                <router-view :state="state" />
            </v-container>
        </v-content>

        <v-footer app>
            <div v-if="state.ipfs">
                <div>id: {{ipfsId.id}}</div>
            </div>
        </v-footer>
    </v-app>
</template>

<script>
import Web3 from 'web3'
import IPFS from 'ipfs'
import NavBar from './components/layouts/NavBar.vue'

export default {
    name: 'app',
    components: {
        NavBar
    },
    data: function () {
        return {
            state: {
                web3: null,
                ipfs: null,
                owner: null
            },
            ipfsId: 0
        }
    },
    methods: {
        getSwarm : async function () {
            const peers = await this.state.ipfs.swarm.peers()
            for (var peer of peers) {
                console.log(peer.addr.toString())
            }
        }
    },
    created: async function () {
        if (window.ethereum) {
            this.state.web3 = new Web3(window.ethereum)

            try {
                await window.ethereum.enable()
            } catch (error) {
                console.log('something went wrong')
            }
        } else if (window.web3) {
            this.state.web3 = new Web3(window.web3.currentProvider);
        } else {
            console.log('Non-Ethereum browser detected. You should try MetaMask!');
        }

        if (this.state) {
            const accounts = await this.state.web3.eth.getAccounts()
            this.state.owner = accounts[0]
        }

        this.state.ipfs = await IPFS.create({
            EXPERIMENTAL: {
                pubsub: true
            },
            "relay": {
                "enabled": true,
                "hop": {
                    "enabled": true
                }
            },
            "config": { "Addresses": { "Swarm": [] } }
        })

        this.state.ipfs.swarm.connect("/ip4/127.0.0.1/tcp/4003/ws/ipfs/QmacFWNvpsq5wEnL199Zxzp86LB9MFYmEDzrhb89LaZkxW")

        window.ipfs = this.state.ipfs

        this.ipfsId = await this.state.ipfs.id()
    },
    destroyed: async function() {
        console.log('disconnect ipfs')
        await this.state.ipfs.stop()
    }
}
</script>

<style>
#app {
    font-family: 'Avenir', Helvetica, Arial, sans-serif;
    -webkit-font-smoothing: antialiased;
    -moz-osx-font-smoothing: grayscale;
    text-align: center;
    color: #2c3e50;
    margin-top: 60px;
}
</style>
